package com.ruoyi.app.family.photo.service.impl;

import com.ruoyi.app.family.album.domain.TbFamilyAlbum;
import com.ruoyi.app.family.album.service.ITbFamilyAlbumService;
import com.ruoyi.app.family.photo.domain.TbFamilyPhoto;
import com.ruoyi.app.family.photo.mapper.TbFamilyPhotoMapper;
import com.ruoyi.app.family.photo.service.ITbFamilyPhotoService;
import com.ruoyi.common.config.RuoYiConfig;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.exception.CustomException;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.utils.file.FileUploadUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;


/**
 * 家族相簿照片
 *
 * @author luobo
 * @date 2020-10-14
 */
@Service
public class TbFamilyPhotoServiceImpl extends ServiceImpl<TbFamilyPhotoMapper, TbFamilyPhoto> implements ITbFamilyPhotoService {
    @Autowired
    private ITbFamilyAlbumService familyAlbumService;

    @Override
    public Boolean batchUpload(Long userId, Long albumId, MultipartFile[] files, String modName) {
        //查询相簿信息
        TbFamilyAlbum albumEntity = familyAlbumService.getEntityById(albumId);
        if (albumEntity == null) {
            throw new CustomException("请选择相簿！");
        }
        try {

            // 上传文件路径
            String filePath = RuoYiConfig.getUploadPath();
            //@TODO 上传添加模块名称 luobo
            if (StringUtils.isNotEmpty(modName) && !modName.equalsIgnoreCase("null") && !modName.equalsIgnoreCase("undefined")) {
                filePath += "/" + modName;
            }
            List<TbFamilyPhoto> list = new ArrayList<>();
            for (MultipartFile item : files) {
                TbFamilyPhoto entity = new TbFamilyPhoto();
                entity.setAlbumId(albumEntity.getId());
                entity.setFamilyId(albumEntity.getFamilyId());
                String title = item.getOriginalFilename();
                title = title.substring(0, title.lastIndexOf("."));
                entity.setTitle(title);


                // 上传并返回新文件名称
                String fileName = FileUploadUtils.upload(filePath, item);
                entity.setUrl(fileName);
                entity.setCreateBy(userId);
                entity.setCreateTime(new Date());
                entity.setStatus("0");
                entity.setDelFlag("0");
                list.add(entity);
            }
            // 上传并返回新文件名称
            if (list.size() > 0) {
                this.saveBatch(list);
            }
            return true;
        } catch (Exception e) {
            throw new CustomException(e.getMessage());
        }

    }
}
