package com.ruoyi.app.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.ruoyi.app.domain.TbFamily;
import com.ruoyi.app.service.ITbFamilyService;
import com.ruoyi.common.utils.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.ruoyi.app.mapper.TbFamilyEventsMapper;
import com.ruoyi.app.domain.TbFamilyEvents;
import com.ruoyi.app.service.ITbFamilyEventsService;

import java.util.List;

/**
 * 家族大事件
 *
 * @author liuhj
 * @date 2020-10-14
 */
@Service
public class TbFamilyEventsServiceImpl extends ServiceImpl<TbFamilyEventsMapper, TbFamilyEvents> implements ITbFamilyEventsService {
    @Autowired
    private ITbFamilyService familyService;


    @Override
    public List<TbFamilyEvents> queryList(TbFamilyEvents  entity) {
        LambdaQueryWrapper<TbFamilyEvents> lqw = new LambdaQueryWrapper<TbFamilyEvents>().orderByDesc(TbFamilyEvents::getCreateTime);
        if (entity.getFamilyId() != null){
            lqw.eq(TbFamilyEvents::getFamilyId ,entity.getFamilyId());
        }
        if (StringUtils.isNotBlank(entity.getTitle())){
            lqw.like(TbFamilyEvents::getTitle ,entity.getTitle());
        }
        List<TbFamilyEvents> list = this.list(lqw);
        list.forEach(item->{
            TbFamily family = familyService.getById(item.getFamilyId());
            item.setFamily(family);
        });

        return list;
    }

}
